% DRAWfigWithCR.m displays Fig 6a and 6b for typical execution i0  

load('WSP_CR_i0', 'uRHC','stare','LIGHTv','mass','x00','m0','i0');

INIT_CONST;
t_fin=120;
 


u_vector=uRHC;
t_vector=0:1:t_fin; %it has 121 components


Lumv1=[0 K3*LIGHTv]; %Put 0 as first element


figure(61) % (a)
stairs(t_vector,[uRHC uRHC(120)],'r');
xlabel('time [h]');
ylabel('quasi-optimal light intensity ');
axis([0,120,300,1100]);
grid MINOR;

text(20.,900.,'\it{control output}','FontSize',12);
text(20.,1050,'Closed-loop with control ranges','FontSize',12);

figure(62)
plot(t_vector,stare,'r',t_vector,Lumv1/2,'b',t_vector,mass,'k',[0 120],[3 3],'--k');
axis([0,120,0,5.]);
xlabel('time [h]');
ylabel('state variables');
legend('\it{x}_{1}','\it{x}_{2}','\Deltam','location','NorthWest');  
% text(10.,190.,'\it{H}=20','FontSize',12);
% text(10.,170,'open-loop','FontSize',12);
grid MINOR;
text(40.,4.75,'Process evolution','FontSize',12);
text(30.,2.75,'m_{0}','FontSize',12);
text(75.,3.5,'0.5\cdot\it{x}_2','FontSize',12);
text(70.,1.,'\Deltam(120)\geq{m}_{0}','FontSize',12);
