function PredCMP=INV_PSO_Predictor3(k,xzero)
% Predictor3 with Control Range and Tuning
%It generates the predicted command profile (CMP) using adaptive PSO
% Inputs: the initial moment of the prediction horizon (k), 
%              the initial state of the process (at moment k)
 
% Output: PredCMP is a vector having h=n-k elements (maximum n (120) elements).

global BEST
global ns n;
global NF MINNF T TT ; %dTdtmax;
global vmax xmin xmax;
global C1min C1max C2min C2max C3min C3max wmin wmax
global Pbest;
global xm xM;
global Ustar;
fitness=zeros(ns,1);%valorile functiei obiectiv pentru particule la iteratia t
h=n-k;
% str=sprintf('h=%3d', h);disp(str);
BEST=zeros(ns,1);   %memoreaza valoarea de fitness pt Pbest(i),i=1,...,ns;
Pbest=zeros(ns,h); 
% xm=xmin*ones(1,h);
% xM=xmax*ones(1,h);
xmh=xm(k+1:n);
xMh=xM(k+1:n);

deltam=(1./3.)*(xmh-xmin); %deltam is a vector
deltaM=(1./3.)*(xmax-xMh); %deltam is a vector

v=zeros(ns,h);
x=zeros(ns,h);


%****************************
%****************************
%****************************
%ARH INCEPUT - predictie cu PSO pe un orizont [k, t_fin]
%****************************
%****************************
%****************************


%Generare aleatoare a vitezelor particulelor x(i,:), i=1,...,ns
for i=1:ns
    for d=1:h
    v(i,d)=random('unif',-vmax,vmax);
    end
end

for i=11:ns
    for d=1:h
      x(i,d)=100*i+random('unif',-100,100);
    end
end 
%Generare 
for i=1:10   
      x(i,:)=Ustar(k+1:n);
end 




% Memoreaza pozitia particulei i ca fiind cea mai buna intalnita pana acum
 % de ea insasi. In BEST(i) s-a memorat si valoarea de fitness
for i=1:ns
    BEST(i)=RHC_EvalFitnessJ13(x(i,:),xzero,k);
    Pbest(i,:)=x(i,:);
    fitness(i)=BEST(i);    
    %str=sprintf('particula %2d are valoare best=%6.3f',i,BEST(i));disp(str);   
end

[GBEST,ig]=min(fitness);
Pgbest=x(ig,:);
if (GBEST==inf) 
    disp('ATENTIE: Toate initializarile nu respecta restrictia de masa');
end;


gasit=0;
t=1;
t0=30; %or TT/3;
%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(t<=T)&&(gasit==0)

SHIFT();
w=wmax-(wmax-wmin)*((t-1)/(TT-1)); %Scade de la wmax la wmin
C1=C1min+(C1max-C1min)*((t-1)/(TT-1));
C2=C2min+(C2max-C2min)*((t-1)/(TT-1));
C3=C3min+(C3max-C3min)*((t-1)/(TT-1));
if(t>=TT) 
    w=wmin;
end

if(t>=t0)
   for i=1:h 
    xmh(i)=xmh(i)-deltam(i);
    if(xmh(i)<xmin)
        xmh(i)=xmin;
    end
    xMh(i)=xMh(i)+deltaM(i);
    if(xMh(i)>xmax)
        xMh(i)=xmax;
    end
   end
    t0=t0+30;
end  
%iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii BEGIN

for i=1:ns
 %TRATEAZA PARTICULA i
 
 %Genereaza Plbest (local best) pentru particula i
 % ca sa aplic formula. Plbest este doar un vector (1,n)
 % ce contine solutia best a celei mai bune informatoare
 %[Plbest,val]=Gen_Plbest(i);
 [Plbest,~]=Gen_Plbest_reg(i);
 %pause;
 
 %dddddddddddddddddddddddddddddddddddddddddddd BEGIN
 for d=1:h
  rand1=random('unif',0,1);
  rand2=random('unif',0,1);
  rand3=random('unif',0,1);
  
v(i,d)= w*v(i,d)+ C1*rand1*(Pbest(i,d)-x(i,d))+C2*rand2*(Plbest(d)-x(i,d));
v(i,d)= v(i,d)+C3*rand3*(Pgbest(d)-x(i,d));
  
 x(i,d)= x(i,d)+v(i,d);
 
  % AICI limitare viteza
  if v(i,d)>vmax
      v(i,d)=vmax;
      elseif v(i,d)<-vmax
        v(i,d)=-vmax;
  end
  
  % AICI limitare x(i,d)
 
 if x(i,d)>xMh(d) 
      x(i,d)=xMh(d) ;
      v(i,d)=-v(i,d);
      elseif x(i,d)<xmh(d)
        x(i,d)=xmh(d);
        v(i,d)=-v(i,d);
 end
 end %dupa componenta d
%dddddddddddddddddddddddddddddddddddddddddddd END

% Evaluate the fitness f(xi) 
 fitness(i)=RHC_EvalFitnessJ13(x(i,:),xzero,k);
 if fitness(i)<BEST(i)  %eps
         BEST(i)=fitness(i);
         Pbest(i,:)=x(i,:);
         %str=sprintf('&&&  t=%3d  BEST(%d) devine %6.3f',t,i,fitness(i));disp(str);
         NF(i)=0;
         if fitness(i)<GBEST
            GBEST=fitness(i);
            Pgbest=x(i,:);
            %str=sprintf('&&&&&&&&  t=%3d GBEST(%d) devine %6.3f',t,i,fitness(i));disp(str);
         end;
    else NF(i)=NF(i)+1;
                
 end
 
 end %dupa particula i
%iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii END

 
%  if(mod(t,10)==0)
%  str=sprintf('        t=%d GBEST=%8.5f',t,GBEST);disp(str);
% end

if(min(NF)==MINNF)
 %str=sprintf('#####   Apeluri fitness=%d',Napel);disp(str);
 gasit=1;
end
t=t+1;

end     %CICLU MARE (dupa t)-while
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt END
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt END

PredCMP=Pgbest;
if(t>TT)
    disp('Algorithm non convergent');
end
str=sprintf('&&&&&&&&  t=%3d GBEST=%6.3f',t,GBEST);
disp(str);
end