% Script that saves the parameters of the typical execution when using
% CRandT (control ranges with tuning).
% The work space "WSP_CRandT_i0" stores these parameters by instruction #43
load('WSP30_CRandT','Mat_uRHC', 'MatJ','AvgNCalls');
INIT_CONST;
i0=17;

t_fin=120;
x00=0.36;
m0=3;
LIGHTv=zeros(1,t_fin);

jj=i0;
uRHC=Mat_uRHC(jj,:);
global u_vector t_vector;
u_vector=uRHC;
t_vector=0:1:t_fin;
IndF=length(t_vector);
stare=zeros(t_fin+1,1);
x0=x00;
stare(1)=x0;
for k=0:1:t_fin-1
    uk=Mat_uRHC(jj,k+1);
    xnext=RHC_RealProcessStep(uk,x0,k);
    x0=xnext;
    stare(k+2)=x0;
end
 mprod=V*(stare(IndF)-x00);
 LUM=K3*sum(u_vector);
J= 10*(mprod-m0)+LUM; 
 
str=sprintf('\n\n Final values with "stare"');
disp(str);
str=sprintf('&&&  yield mass=%7.4f  Light=%7.4f  Perf Index=%7.4f ',mprod,LUM, J);
disp(str);
  %Light amount
LIGHTv(1)=Mat_uRHC(jj,1);
for i=2:t_fin
    LIGHTv(i)=LIGHTv(i-1)+Mat_uRHC(jj,i);
end

mass=V*(stare-x00);
save('WSP_CRandT_i0', 'uRHC','stare','LIGHTv','mass','x00','m0','i0');


Lumv1=[0 K3*LIGHTv]; %Put 0 as first element

uRHC=Mat_uRHC(jj,:);
figure(1)
plot(t_vector,stare,'r',t_vector,mass,'k',t_vector,Lumv1,'b');
grid MINOR;
figure(2)
stairs(t_vector,[uRHC uRHC(120)],'r');
grid MINOR;  