%Afisari Fig 1 si 2 dupa mediere -caz cusenzor in versiunea v2

load('WSPcuSZv2_i0','i0','xxMuRHC','xxMstare','xxJ','xxmprod','xxLUM','xxNAp','uRHC','stare','x00','m0');

INIT_CONST;
t_fin=120;
LIGHTv=zeros(1,t_fin); 


u_vector=uRHC;
t_vector=0:1:t_fin;

IndF=length(t_vector);
LUM=K3*sum(u_vector);
mprod=V*(stare(IndF)-x00);
J= 10*(mprod-m0)+LUM; 
NapelAvg=xxNAp(i0);
str=sprintf('\n\n Final values for Overall integration using uRHC');disp(str);
str=sprintf('&&&  yield mass=%7.4f  Light=%7.4f  Perf Index=%7.4f   NapelAvg=%7.0f ',...
    mprod,LUM, J,NapelAvg);disp(str);

%Light amount
LIGHTv(1)=uRHC(1);
for i=2:t_fin
    LIGHTv(i)=LIGHTv(i-1)+uRHC(i);
end
Lumv1=[0 K3*LIGHTv]; %Put 0 as first element
mass=V*(stare-x00);

figure(81)
stairs(t_vector,[uRHC uRHC(120)],'r');
xlabel('time [h]');
ylabel('control output ');
axis([0,120,150.,1650]);
grid MINOR;
%text(3.2,2,strcat('Q_{0}=',num2str(Q0)),'FontSize',14);
text(40.,900.,'\it{quasi-optimal light intensity}','FontSize',12);
text(20.,1550,'closed-loop with SENSOR mode=2','FontSize',12);


figure(82)
plot(t_vector,stare,'r',t_vector,Lumv1/2,'b',t_vector,mass,'k');
axis([0,120,0,5.]);
xlabel('time [h]');
ylabel('state variables');
legend('biomass concentration [g/L]','amount of light [mol photons/m2/h]',...
    'produced biomass [g]','location','NorthWest'); %,'position',[100 180 100 120];

grid MINOR;
text(60.,3.,'0.5*amount of light','FontSize',12);
text(70.,1.,'\it{m}_{0}=3. g','FontSize',12);