% RHC without SENSOR
% Particle Swarm Optimization - PhotoBioReactor Optimal Control


% Se minimizeaza cantitatea de lumina 
% Cu restrictie masa produsa > =m0
% VARIANTA cu registru la vecinii sociali
% Cu STEP Control, RHC_EvalFitnessJ13, BatchPBR8 (ecuatii), sim_PBRJ13
% x0 are dimensiunea 1;
% Iluminare calculata la sfarsit pt Yield, dar in sim_PBR8 este refacuta 
% pt tot orizontul de conducere, pe acelasi principiu, pentru afisare.
% 
% Initializare mai complexa a prticulelor

disp('RHC_PSO_PBRJ13');
disp('PhotoBioReactor Optimal Control ');
disp('Local best: [Plbest,val]=Gen_Plbest_reg(i)');
global n ns;
%global x; %pozitii
%global v; %viteze
global x00 x0 m0;
global t_fin;
%global GBEST;    % scalar cu valoarea GBEST
%global BEST;     % vector (ns,1) cu valorile best ale particulelor
%global Pbest;    % matrice(ns,n)
%global Pgbest;   % vector (1,n) pt particula global best

global t_vector;  %depinde de problema!!
global Napel Napel_C;
global B;
global kz KGz;
global NF MINNF T TT dTdtmax;
global vmax xmin xmax;
global C1min C1max C2min C2max C3min C3max wmin wmax;
%global uRHC;
global u_vector;
global command_index;
global uRHC;

%global xini
ns=15;
t_fin=120;
n=120; % Nr.de comenzi
m0=3.;

uRHC=zeros(1,n);  % memoreaza comenzile date de regulatorul RHC
%x=zeros(ns,n);    %memoreaza pozitia particulelor la un moment dat

%v=zeros(ns,n);    %memoreaza viteza particulelor la un moment dat
NF=zeros(ns,1);  %memoreaza nr de stagnari ale solutiei best pt
                          % particula i=1,...,ns
B=zeros(ns,1);
for kk=1:ns
    B(kk)=kk;
end
stare=zeros(n+1,1);

%////////////////////////
%////////////////////////
%Particle swarm's parameters initialization
vmax=5.;

xmin=50;
xmax=2000;

C1min=0.5;
C1max=2.;
C2min=1.; %0.5
C2max=2.; %1.5
C3min=0.5;%1
C3max=1.5;%2

wmin=0.2;
wmax=0.6;

T=1000; %Nr max de iteratii
TT=300; %artificiu. 
%////////////////////////
%////////////////////////

MINNF=1;
dTdtmax=50.;
%***************************************************
%***************************************************
%PBR Model's parameters initialization

global V mumax Ki Kii mus K3 D
A = 0.0375; % PBR lighted area [m2]
V = 1.45;   % PBR volume [L]
L = 0.04;   % torus PBR depth [m]
Ea = 172;   % mass absorption coefficient [m2/kg]
Es = 870;   % mass scattering coefficient [m2/kg]
b = 0.0008; % backward scattering fraction [-]
mumax=0.16; % maximum specific growth rate [h-1]
Ki=120;     % irradiance half-saturation constant [mol/m2/s]
Kii = 2500; % irradiance inhibition constant [mol/m2/s]
mus=0.013;  % maintenance rate [h-1]
alpha = (Ea/(Ea+2*b*Es))^(1/2);
z = linspace(0,L,100);
kz=length(z);
KGz=zeros(1,100);
for i=1:kz
 KGz(i) = exp(-(1+alpha)/2/alpha*Ea*z(i));    % Irradiance (light inside the culture) (umol/m2/s)
end
K3=A*3600/1e6; 
%***************************************************
%***************************************************
D=0;
% Other initializations
x00=0.36;
x0=x00;
Napel_C=0;
stare(1,:)=x0; %memorare stare initiala
k=0;
deltat=1.;

%***************************************************
%***************************************************
%         CLOSED-LOOP control structure
%***************************************************
%***************************************************
while k<=(t_fin-1) 
    
    
 str=sprintf('#####                                                              k=%d',k);disp(str);
 %k este capatul din stanga al orizontului de predictie
  %str=sprintf('#####  starea curenta=%7.3f',x0);disp(str);
   
  kp1=k+1;
  
  Napel=0;
 %[xm1, xM1, ~]=SENSOR(x0,deltat);  %x0: Conc biomasa;
 % xm1, xM1 are the bounds of the first control value
 xm1=xmin;
 xM1=xmax;
%  str=sprintf('limitele comenzii:   minima=%7.2f  maxima=%7.2f ',xm1,xM1);
%  disp(str);
 
 PredictedSeq=RHC_Predictor_SZ(k,x0,xm1,xM1);
   


%Afisare predictie
u_vector=PredictedSeq;
t_vector=k:1:t_fin;
command_index=1;
[tv,Y] = ode45('BatchPBR8',t_vector,x0);
IndF=length(tv);
LUM=K3*sum(u_vector);
mprod=V*(Y(IndF)-x00); %ATENTIE x00
J= 10*(mprod-m0)+LUM; 
Napel_C=Napel_C+Napel;
str=sprintf('&&&  masa=%7.4f  J=%7.4f  Napel=%6d  Napel_C= %6d',...
    mprod,J,Napel,Napel_C);disp(str);

%pause;

% TRIMITERE (sau SALVARE) COMANDA U(k)
 uk=PredictedSeq(1);
 uRHC(kp1)=uk;
%  str=sprintf('&&&  comanda trimisa la proces=%7.4f ',uk);
%  disp(str);
%disp('*********************************////////////');
  % CITIRE STARE CURENTA pt iteratia urmatoare
  % De fapt AICI SIMULEZ STAREA CURENTA
  xnext=RHC_RealProcessStep(uk,x0,k);
  x0=xnext;
  % x0 devine noua stare initiala
  %RPM = PM deci nu adaug nimic acum
  
  k=kp1;  %k pt iteratia urmatoare
  %memorare stare initiala pt pasul urmator
  stare(k+1)=x0;
  
end

SimFin;
