function PredCMP=RHC_Predictor_SZv2(k,xzero,uoy)
% It generates the predicted command profile (CMP) using adaptive PSO
% Inputs: the initial moment of the prediction horizon (k), 
%              the initial state of the process xzero (at moment k)
 % xm1, xM1 are the limits of the first control value
% Output: PredCMP is a vector having h=n-k elements (maximum n (120) elements).

global BEST
global ns n;
global NF MINNF T TT ; %dTdtmax;
global vmax xmin xmax
global C1min C1max C2min C2max C3min C3max wmin wmax
global Pbest
%global Napel
%global uRHC;
fitness=zeros(ns,1);%valorile functiei obiectiv pentru particule la iteratia t
h=n-k;
% str=sprintf('h=%3d', h);disp(str);
BEST=zeros(ns,1);   %memoreaza valoarea de fitness pt Pbest(i),i=1,...,ns;
Pbest=zeros(ns,h);
p=0.2;
xm=xmin*ones(1,h);
xM=xmax*ones(1,h);
xm(1)=(1-p)*uoy;
xM(1)=(1+p)*uoy;
v=zeros(ns,h);
x=zeros(ns,h);
%x00=0.36;
NF=zeros(ns,1); %memoreaza nr de stagnari ale solutiei best pt
                          % particula i=1,...,ns
%****************************
%****************************
%****************************
%ARH INCEPUT - predictie cu PSO pe un orizont [k, t_fin]
%****************************
%****************************
%****************************

%Generare aleatoare a vitezelor particulelor x(i,:), i=1,...,ns
for i=1:ns
    for d=1:h
    v(i,d)=random('unif',-vmax,vmax);
    end
end
 
%Generare aleatoare a pozitiilor particulelor x(i,:), i=1,...,ns
for i=1:ns
    %x(i,1)=random('unif',xm(1),xM(1));
    for d=1:h
      x(i,d)=100*i+random('unif',-100,100) ;
    end    
end

% Memoreaza pozitia particulei i ca fiind cea mai buna intalnita pana acum
 % de ea insasi. In BEST(i) s-a memorat si valoarea de fitness
for i=1:ns
    %str=sprintf('x(%2d)=%7.2f  %7.2f ... %7.2f  %7.2f ',i,x(i,1),x(i,2),x(i,16),x(i,17));disp(str);
    BEST(i)=RHC_EvalFitnessJ13(x(i,:),xzero,k);
    Pbest(i,:)=x(i,:);
    fitness(i)=BEST(i);
    %str=sprintf('particula %2d are valoare best=%6.3f',i,BEST(i));disp(str);   
end

[GBEST,ig]=min(fitness);
GBEST0=GBEST;
Pgbest=x(ig,:);
if (GBEST==inf)
    %Pgbest=x(ns,:);
    disp('ATENTIE: Toate initializarile nu respecta restrictia de masa');
end;


gasit=0;
t=1;
%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(t<=T)&&(gasit==0)

SHIFT();
w=wmax-(wmax-wmin)*((t-1)/(TT-1)); %Scade de la wmax la wmin
C1=C1min+(C1max-C1min)*((t-1)/(TT-1));
C2=C2min+(C2max-C2min)*((t-1)/(TT-1));
C3=C3min+(C3max-C3min)*((t-1)/(TT-1));
if(t>=TT) 
    w=wmin;
end
   
%iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii BEGIN

for i=1:ns
 %TRATEAZA PARTICULA i
 
 %Genereaza Plbest (local best) pentru particula i
 % ca sa aplic formula. Plbest este doar un vector (1,n)
 % ce contine solutia best a celei mai bune informatoare
 %[Plbest,val]=Gen_Plbest(i);
 [Plbest,~]=Gen_Plbest_reg(i);
 %pause;
 
 %dddddddddddddddddddddddddddddddddddddddddddd BEGIN
 for d=1:h
  rand1=random('unif',0,1);
  rand2=random('unif',0,1);
  rand3=random('unif',0,1);
  
  v(i,d)= w*v(i,d)+ C1*rand1*(Pbest(i,d)-x(i,d))+C2*rand2*(Plbest(d)-x(i,d));
  v(i,d)= v(i,d)+C3*rand3*(Pgbest(d)-x(i,d));
 
  x(i,d)= x(i,d)+v(i,d);
  
 % AICI limitare viteza
  if v(i,d)>vmax
      v(i,d)=vmax;
      elseif v(i,d)<-vmax
        v(i,d)=-vmax;
  end
  
  % AICI limitare x(i,d)
 
   if x(i,d)>xM(d) 
      x(i,d)=xM(d) ;
      v(i,d)=-v(i,d);
      elseif x(i,d)<xm(d)
        x(i,d)=xm(d);
        v(i,d)=-v(i,d);
   end
end %dupa componenta d
%dddddddddddddddddddddddddddddddddddddddddddd END

% Step control
%   if k>0
%       if x(i,1)-uRHC(k)>dTdtmax
%          x(i,1)=uRHC(k)+dTdtmax;
%        elseif x(i,1)-uRHC(k)<-dTdtmax
%          x(i,1)=uRHC(k)-dTdtmax;
%       end;
%   end
% for d=1:h-1
%   if x(i,d+1)-x(i,d)>dTdtmax
%     x(i,d+1)=x(i,d)+dTdtmax;
%   elseif x(i,d+1)-x(i,d)<-dTdtmax
%     x(i,d+1)=x(i,d)-dTdtmax;
%   end
% end

%str=sprintf('x(%2d)=%7.2f  %7.2f ... %7.2f  %7.2f ',i,x(i,1),x(i,2),x(i,16),x(i,17));disp(str);
% Evaluate the fitness f(xi) 
fitness(i)=RHC_EvalFitnessJ13(x(i,:),xzero,k);
%  if (x(i,1)>xM(1))||(x(i,1)<xm(1))
%      disp('bounds ERROR');
 % end
 if fitness(i)<BEST(i)  
         BEST(i)=fitness(i);
         Pbest(i,:)=x(i,:);
         %str=sprintf('&&&  t=%3d  BEST(%d) devine %6.3f',t,i,fitness(i));disp(str);
         NF(i)=0;
         if fitness(i)<GBEST
            GBEST=fitness(i);
            Pgbest=x(i,:);
            %str=sprintf('&&&&&&&&  t=%3d GBEST(%d) devine %6.3f',t,i,fitness(i));disp(str);
         end;
    else NF(i)=NF(i)+1;
                
 end
 
 end %dupa particula i
%iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii END

 
%  if(mod(t,10)==0)
%  str=sprintf('        t=%d GBEST=%8.5f',t,GBEST);disp(str);
% end

if (min(NF)>=MINNF)  
   if  (GBEST<GBEST0)
       gasit=1;
    else 
    xm(1)=xmin;
    xM(1)=xmax;
    disp('                             @@@@@relaxare limite');
   end
end
   
   t=t+1;

end     %CICLU MARE (dupa t)-while
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt END
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt END

PredCMP=Pgbest;
% if (PredCMP(1)>xM(1))||(PredCMP(1)<xm(1))
%      disp('bounds ERROR');
%      pause;
%  end
end