function [umin, umax, uoy]=SENSOR(x01,deltat)
%INPUT x01: Conc biomasa;
%           deltat: lungime interval de evolutie
%OUTPUT: umin si umax din intervalul care asigura cresterea biomasei;
%                uoy- comanda care asigura un randament maxim pe intervalul de estimare

% Utilizeaza pt integrare XXEvalState care integreaza la randul lui cu
% XXBatchPBR ce foloseste un model cu 2 stari 
% (Conc biom, Specific Growth Rate)
% Principiu: Baleiaza valorile din vectorul Vector_q0 cu intensitati q0

Vector_q0= 1:50:2000;
nv=length(Vector_q0);
p=0.8; %procent

Bc=zeros(1,nv);
Sg=zeros(1,nv);
Yx=zeros(1,nv);

XZ=[x01 0.]; %completare cu 0. pe pozitia Specific Growth Rate pt a forma starea XZ

for j = 1:nv
  qzero = Vector_q0(j);
 
  [Bc(j),Sg(j),Yx(j)]=XXEvalState(XZ,qzero,deltat);
  if Yx(j)<0
    Yx(j)=0.;
  end
end

%Determinare simpla umin
gata=0;
k=1;
while k<nv && gata==0
  if (Sg(k)>0)
      gata=1; 
  else k=k+1;
  end
end
umin=Vector_q0(k);

%Determinare simpla umax: valoare umax implica cea mai apropiata
% valoare de p% din maximul de Sg.
Sg80=p*max(Sg);
k0=1;
dif=abs(Sg(k0)-Sg80);
for m=2:nv
    dx=abs(Sg(m)-Sg80);
    if(dx<dif)
        dif=dx;
        k0=m;
    end
end
umax=Vector_q0(k0);

%Determinare simpla uoy
[~, I]=max(Yx);
uoy=Vector_q0(I);
end

    


