function dx = XXBatchPBR(~,x)
% x(1):Biomass concentration;
% x(2): Specific growth rate, 
global mumax Ki Kii mus;
global kz
global KGz
global q0;
global D;

Gz=zeros(1,kz);
mu=zeros(1,kz);

for i=1:kz
%Gz(i) = q0*exp(-(1+alpha)/2/alpha*Ea*x(1)*z(i));
% Irradiance (light inside the culture) (umol/m2/s)
  Gz(i) = q0*(KGz(i))^x(1);
  mu(i) = mumax*Gz(i)/(Ki+Gz(i)+(Gz(i)^2)/Kii);
end


%mu = (mumax*Gz.*(((Ki+Gz+(Gz.^2)/Kii).^(-1)))); 
% local photosynthetic responses (1/h) - Inhibition Model
MuPhoto = mean(mu);                             % average photosynthetic response (1/h)
rxp = MuPhoto*x(1);                           % volumetric GROWTH rate (g/L/h)
rxd = mus*x(1);                                  % volumetric DECLINE rate (g/L/h)
rx = rxp - rxd;                                      % volumetric rate (g/L/h)

dx(1) = rx-D*x(1);                                 % Biomass concentration (g/L)
dx(2) = MuPhoto - mus - x(2);         % Specific growth rate (h-1)
dx=dx';

end