function [Bc,Sgr,Yield]=XXEvalState(x0p,q0p,deltat)
%INPUT x0p: stare cu 2 componente (Conc biom, Specific Growth Rate);
%           q0p: intensitate lumina pe intervalul deltat
%           deltat: interval de evolutie
%OUTPUT: Conc biom, Specific Growth Rate, Yield claculat pe durata estimarii

global K3;
global V;
global q0;

q0=q0p; %Pentru comunicare cu XXBatchPBR

M = [1 0
        0 0];
odeoptions = odeset('Mass',M);
[tv,Y] = ode15s(@XXBatchPBR,[0, deltat],x0p,odeoptions); 
IndF=length(tv);


% AICI CALCUL VALOARI RETURNATE
% cu ajutorul starii finale din Y(:) si tv(:)

LUM=K3*q0*deltat;
mprod=V*(Y(IndF,1)-x0p(1)); %V*(Y(IndF,1));   
Yield=mprod/LUM;
Bc=Y(IndF,1);
Sgr=Y(IndF,2);

% **********************************************
%Napel=Napel+1;
end
